package queue;

public class NormalQueue implements Queue {
  PriorityObject[] array;
  int first, last;
  int size;

  public NormalQueue() {
    this(100);
  }

  public NormalQueue(int size) {
    array = new PriorityObject[size];
    first = last = 0;
    this.size = size;
  }

  public PriorityObject pop() {
    if(first != last) {
      PriorityObject pom = array[first];
      array[first] = null;
      first = (first + 1) % size;
      return pom;
    }
    else throw new ArrayIndexOutOfBoundsException("Queue empty");
  }

  public void push(PriorityObject po) {
    if(((last + 1) % size) == first) {
      PriorityObject[] pom = new PriorityObject[size*2];
      System.arraycopy(array, first, pom, 0, size-first);
      System.arraycopy(array, 0, pom, size-first, last);
      array = pom;
      first = 0;
      last = size-1;
      size = 2 * size;
    }
    array[last] = po;
    last = (last+1) % size;
  }

  public boolean isEmpty() {
    return first == last;
  }
}
