package queue;

public class PriorityQueue implements Queue {
  PriorityObject[] array;
  int first, last;
  int size;

  public PriorityQueue() {
    this(100);
  }

  public PriorityQueue(int size) {
    array = new PriorityObject[size];
    first = last = 0;
    this.size = size;
  }

  public PriorityObject pop() {
    if(first != last) {
      PriorityObject pom = array[first];
      array[first] = null;
      first = (first + 1) % size;
      return pom;
    }
    else throw new ArrayIndexOutOfBoundsException("Queue empty");
  }

  public void push(PriorityObject po) {
    int index = getIndex(first,last, po.getValue());
    if(((last + 1) % size) == first) {
      PriorityObject[] pom = new PriorityObject[size*2];
      if(index < first) {
        System.arraycopy(array, first, pom, 0, size-first);
        System.arraycopy(array, 0, pom, size-first, index);
        pom[size-first+index] = po;
        System.arraycopy(array, index, pom, size-first+index+1, last-index);
      } else {
        System.arraycopy(array, first, pom, 0, index-first);
        pom[index-first] = po;
        if(index < last) {
          System.arraycopy(array, index, pom, index-first+1, last-index);
        } else {
          System.arraycopy(array, index, pom, index-first+1, size-index);
          System.arraycopy(array, 0, pom, size-first+1, last);
        }
      }
      array = pom;
      first = 0;
      last = size;
      size = 2 * size;
    } else {
      if ((index < first) || (index <= last)) {
        System.arraycopy(array, index, array, index + 1, last - index);
      } else {
        System.arraycopy(array, 0, array, 1, last);
        array[0] = array[size-1];
        System.arraycopy(array, index, array, index+1, size - index - 1);
      }
      array[index] = po;
      last = (last+1) % size;
    }
  }

  public boolean isEmpty() {
    return first == last;
  }

  private int getIndex(int min, int max, int value) {
    int middle = 0;
    if (max == min) {
      if((array[max] == null) || (array[max].getValue() > value)) return max;
      else return (max+1)%size;
    }
    if (min < max) {
      middle = (max + min) / 2;
    }
    else {
      middle = ( (size + max + min) / 2) % size;
    }
    if (array[middle].getValue() == value) return middle;
    else if (array[middle].getValue() > value) return getIndex(min, middle, value);
    else return getIndex((middle+1)%size, max, value);
  }
}
